Crystal::Macros::TupleLiteral - Crystal 1.20.1

# class Crystal::Macros::TupleLiteral

- Crystal::Macros::TupleLiteral
- Crystal::Macros::ASTNode

##
Overview

A tuple literal.

Its macro methods are nearly the same as `ArrayLiteral`.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #*(other : NumberLiteral) : TupleLiteral

  Similar to `Tuple#*`

- #+(other : TupleLiteral) : TupleLiteral

  Similar to `Tuple#+`.

- #-(other : TupleLiteral) : TupleLiteral

  Similar to `Array#-`.

- #<<(value : ASTNode) : TupleLiteral

  Similar to `Array#<<`.

- #[](start : NumberLiteral, count : NumberLiteral) : TupleLiteral | NilLiteral

  Similar to `Array#[]?(Int, Int)`, but returns another `TupleLiteral` instead of an `ArrayLiteral`.

- #[](index : NumberLiteral) : ASTNode

  Similar to `Tuple#[]?(Int)`.

- #[](index : RangeLiteral) : TupleLiteral | NilLiteral

  Similar to `Tuple#[]?(Range)`.

- #[]=(index : NumberLiteral, value : ASTNode) : ASTNode

  Similar to `Array#[]=`.

- #all?(&) : BoolLiteral

  Similar to `Enumerable#all?`

- #any?(&) : BoolLiteral

  Similar to `Enumerable#any?`

- #each(&) : NilLiteral

  Similar to `Tuple#each`

- #each_with_index(&) : NilLiteral

  Similar to `Enumerable#each_with_index`

- #empty? : BoolLiteral

  Similar to `Tuple#empty?`

- #find(&) : ASTNode | NilLiteral

  Similar to `Enumerable#find`

- #first : ASTNode | NilLiteral

  Similar to `Tuple#first`, but returns a `NilLiteral` if the tuple is empty.

- #includes?(node : ASTNode) : BoolLiteral

  Similar to `Enumerable#includes?(obj)`.

- #join(separator) : StringLiteral

  Similar to `Enumerable#join`

- #last : ASTNode | NilLiteral

  Similar to `Tuple#last`, but returns a `NilLiteral` if the tuple is empty.

- #map(&) : TupleLiteral

  Similar to `Enumerable#map`

- #map_with_index(&) : TupleLiteral

  Similar to `Enumerable#map_with_index`

- #push(value : ASTNode) : TupleLiteral

  Similar to `Array#push`.

- #reduce(memo : ASTNode, &) : ASTNode

  Similar to `Enumerable#reduce`

- #reduce(&) : ASTNode

  Similar to `Enumerable#reduce`

- #reject(&) : TupleLiteral

  Similar to `Enumerable#reject`

- #select(&) : TupleLiteral

  Similar to `Enumerable#select`

- #shuffle : TupleLiteral

  Similar to `Array#shuffle`

- #size : NumberLiteral

  Similar to `Tuple#size`

- #sort : TupleLiteral

  Similar to `Array#sort`

- #sort_by(&) : TupleLiteral

  Similar to `Array#sort_by`

- #splat(trailing_string : StringLiteral = nil) : MacroId

  Returns a `MacroId` with all of this tuple's elements joined by commas.

- #uniq : TupleLiteral

  Similar to `Array#uniq`

- #unshift(value : ASTNode) : TupleLiteral

  Similar to `Array#unshift`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def *(other : NumberLiteral) : TupleLiteral #

Similar to `Tuple#*`

def +(other : TupleLiteral) : TupleLiteral #

Similar to `Tuple#+`.

def -(other : TupleLiteral) : TupleLiteral #

Similar to `Array#-`.

def <<(value : ASTNode) : TupleLiteral #

Similar to `Array#<<`.

def [](start : NumberLiteral, count : NumberLiteral) : TupleLiteral | NilLiteral #

Similar to `Array#[]?(Int, Int)`, but returns another `TupleLiteral` instead of an `ArrayLiteral`.

def [](index : NumberLiteral) : ASTNode #

Similar to `Tuple#[]?(Int)`.

def [](index : RangeLiteral) : TupleLiteral | NilLiteral #

Similar to `Tuple#[]?(Range)`.

def []=(index : NumberLiteral, value : ASTNode) : ASTNode #

Similar to `Array#[]=`.

def all?(&) : BoolLiteral #

Similar to `Enumerable#all?`

def any?(&) : BoolLiteral #

Similar to `Enumerable#any?`

def each(&) : NilLiteral #

Similar to `Tuple#each`

def each_with_index(&) : NilLiteral #

Similar to `Enumerable#each_with_index`

def empty? : BoolLiteral #

Similar to `Tuple#empty?`

def find(&) : ASTNode | NilLiteral #

Similar to `Enumerable#find`

def first : ASTNode | NilLiteral #

Similar to `Tuple#first`, but returns a `NilLiteral` if the tuple is empty.

def includes?(node : ASTNode) : BoolLiteral #

Similar to `Enumerable#includes?(obj)`.

def join(separator) : StringLiteral #

Similar to `Enumerable#join`

def last : ASTNode | NilLiteral #

Similar to `Tuple#last`, but returns a `NilLiteral` if the tuple is empty.

def map(&) : TupleLiteral #

Similar to `Enumerable#map`

def map_with_index(&) : TupleLiteral #

Similar to `Enumerable#map_with_index`

def push(value : ASTNode) : TupleLiteral #

Similar to `Array#push`.

def reduce(memo : ASTNode, &) : ASTNode #

Similar to `Enumerable#reduce`

def reduce(&) : ASTNode #

Similar to `Enumerable#reduce`

def reject(&) : TupleLiteral #

Similar to `Enumerable#reject`

def select(&) : TupleLiteral #

Similar to `Enumerable#select`

def shuffle : TupleLiteral #

Similar to `Array#shuffle`

def size : NumberLiteral #

Similar to `Tuple#size`

def sort : TupleLiteral #

Similar to `Array#sort`

def sort_by(&) : TupleLiteral #

Similar to `Array#sort_by`

def splat(trailing_string : StringLiteral = nil) : MacroId #

Returns a `MacroId` with all of this tuple's elements joined by commas.

If trailing_string is given, it will be appended to the result unless this tuple is empty. This lets you splat a tuple and optionally write a trailing comma if needed.

def uniq : TupleLiteral #

Similar to `Array#uniq`

def unshift(value : ASTNode) : TupleLiteral #

Similar to `Array#unshift`.